Package: groovy.ui.text

## [Java] Class TextEditor

- groovy.ui.text.TextEditor

- All Implemented Interfaces and Traits:
    Pageable, Printable

      public class TextEditor
      extends JTextPane

  A simple text pane that is printable and wrapping is optional.

  Authors:
    Evan "Hippy" Slatis

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static String` | `AUTO_INDENT` |
    `static String` | `FIND` |
    `static String` | `FIND_NEXT` |
    `static String` | `FIND_PREVIOUS` |
    `static String` | `REPLACE` |

  - Inherited fields
    Fields inherited from class | Fields
    --- | ---
    `class JTextPane` | `W3C_LENGTH_UNITS, HONOR_DISPLAY_PROPERTIES, FOCUS_ACCELERATOR_KEY, DEFAULT_KEYMAP, WHEN_FOCUSED, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_IN_FOCUSED_WINDOW, UNDEFINED_CONDITION, TOOL_TIP_TEXT_KEY, TOP_ALIGNMENT, CENTER_ALIGNMENT, BOTTOM_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, WIDTH, HEIGHT, PROPERTIES, SOMEBITS, FRAMEBITS, ALLBITS, ERROR, ABORT`
    `class JEditorPane` | `W3C_LENGTH_UNITS, HONOR_DISPLAY_PROPERTIES, FOCUS_ACCELERATOR_KEY, DEFAULT_KEYMAP, WHEN_FOCUSED, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_IN_FOCUSED_WINDOW, UNDEFINED_CONDITION, TOOL_TIP_TEXT_KEY, TOP_ALIGNMENT, CENTER_ALIGNMENT, BOTTOM_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, WIDTH, HEIGHT, PROPERTIES, SOMEBITS, FRAMEBITS, ALLBITS, ERROR, ABORT`

  - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `boolean` | `overtypeMode`
    `boolean` | `unwrapped`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `TextEditor ()` Creates a new instance of TextEditor
    `TextEditor (boolean tabsAsSpaces)` Creates a new instance of TextEditor
    `TextEditor (boolean tabsAsSpaces, boolean multiLineTab)` Creates a new instance of TextEditor
    `TextEditor (boolean tabsAsSpaces, boolean multiLineTab, boolean unwrapped)` Creates a new instance of TextEditor

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `void` | `addNotify()`
    `` | `int` | `getNumberOfPages()`
    `` | `PageFormat` | `getPageFormat(int pageIndex)`
    `` | `Printable` | `getPrintable(int param)`
    `` | `boolean` | `getScrollableTracksViewportWidth()`
    `` | `boolean` | `isMultiLineTabbed()` Whether using the tab key indents the selected lines of code
    `` | `void` | `isMultiLineTabbed(boolean multiLineTab)` @param multiLineTab the new multiLine tab value
    `` | `static boolean` | `isOvertypeMode()` @return true if overtype mode is active, false for insert mode
    `` | `boolean` | `isTabsAsSpaces()` @return true if tabs are converted to spaces upon typing
    `` | `void` | `isTabsAsSpaces(boolean tabsAsSpaces)` @param tabsAsSpaces whether tabs are converted to spaces
    `` | `boolean` | `isUnwrapped()` @return true if text wrapping is disabled
    `` | `int` | `print(Graphics graphics, PageFormat pageFormat, int page)`
    `` | `protected void` | `processKeyEvent(KeyEvent e)`
    `` | `void` | `removeNotify()`
    `` | `void` | `replaceSelection(String text)`
    `` | `void` | `setBounds(int x, int y, int width, int height)`
    `` | `void` | `setOvertypeMode(boolean isOvertypeMode)` Set the caret to use depending on overtype/insert mode
    `` | `void` | `setUnwrapped(boolean unwrapped)` @param unwrapped the new unwrapped value

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class JTextPane` | `getStyle, getUIClassID, addStyle, getCharacterAttributes, getInputAttributes, getLogicalStyle, getParagraphAttributes, getStyledDocument, insertComponent, insertIcon, removeStyle, replaceSelection, setCharacterAttributes, setDocument, setEditorKit, setLogicalStyle, setParagraphAttributes, setStyledDocument, read, getContentType, setContentType, getText, setText, getAccessibleContext, getPreferredSize, addHyperlinkListener, createEditorKitForContentType, fireHyperlinkUpdate, getEditorKitForContentType, getHyperlinkListeners, getPage, registerEditorKitForContentType, registerEditorKitForContentType, removeHyperlinkListener, scrollToReference, setPage, setPage, getScrollableTracksViewportHeight, getScrollableTracksViewportWidth, getEditorKit, getEditorKitClassNameForContentType, setEditorKitForContentType, write, read, getActions, print, print, print, copy, select, getCaret, cut, paste, getMargin, setMargin, getText, selectAll, addInputMethodListener, getInputMethodRequests, setComponentOrientation, getUI, isEditable, setEditable, setUI, updateUI, getToolTipText, removeNotify, getDocument, modelToView, setCaretPosition, addCaretListener, addKeymap, getCaretColor, getCaretListeners, getDisabledTextColor, getFocusAccelerator, getHighlighter, getKeymap, getKeymap, getNavigationFilter, getSelectedTextColor, getSelectionColor, loadKeymap, moveCaretPosition, removeCaretListener, removeKeymap, setCaret, setCaretColor, setDisabledTextColor, setFocusAccelerator, setHighlighter, setKeymap, setNavigationFilter, setSelectedTextColor, setSelectionColor, setSelectionEnd, setSelectionStart, viewToModel, getSelectedText, getDragEnabled, getDropLocation, getDropMode, getPreferredScrollableViewportSize, getPrintable, getScrollableBlockIncrement, getScrollableUnitIncrement, setDragEnabled, setDropMode, getCaretPosition, getSelectionEnd, getSelectionStart, update, contains, getLocation, print, getSize, isOpaque, disable, enable, setEnabled, getBounds, revalidate, addAncestorListener, firePropertyChange, firePropertyChange, firePropertyChange, getClientProperty, getListeners, addNotify, addVetoableChangeListener, computeVisibleRect, createToolTip, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getRegisteredKeyStrokes, getRootPane, getToolTipLocation, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintImmediately, paintImmediately, printAll, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, resetKeyboardActions, reshape, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, add, add, add, add, add, remove, remove, list, list, removeAll, invalidate, locate, layout, addPropertyChangeListener, addPropertyChangeListener, validate, getComponent, getLayout, getComponents, getComponentAt, getComponentAt, findComponentAt, findComponentAt, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getMousePosition, insets, isAncestorOf, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, minimumSize, paintComponents, preferredSize, printComponents, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, getFocusTraversalPolicy, isFocusCycleRoot, isFocusCycleRoot, setFocusTraversalPolicy, addContainerListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, getComponentCount, add, remove, toString, getName, contains, size, getLocation, getParent, setName, list, list, list, getSize, location, setSize, setSize, resize, resize, enable, isValid, isEnabled, action, bounds, getBounds, removePropertyChangeListener, removePropertyChangeListener, getLocale, setLocale, move, getGraphicsConfiguration, getMousePosition, handleEvent, isFocusOwner, isFocusable, isLightweight, postEvent, transferFocus, transferFocusBackward, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, checkImage, checkImage, createImage, createImage, createVolatileImage, createVolatileImage, enableInputMethods, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getKeyListeners, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMouseWheelListeners, getToolkit, gotFocus, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isFocusTraversable, isFontSet, isForegroundSet, keyDown, keyUp, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, paintAll, prepareImage, prepareImage, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, setCursor, setDropTarget, setFocusTraversalKeysEnabled, setFocusable, setIgnoreRepaint, show, show, transferFocusUpCycle, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getFocusCycleRootAncestor, getFont, getForeground, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getTreeLock, isDisplayable, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isVisible, nextFocus, repaint, repaint, repaint, setBounds, setBounds, setLocation, setLocation, dispatchEvent, wait, wait, wait, equals, hashCode, getClass, notify, notifyAll`
    `class JEditorPane` | `read, getContentType, setContentType, getText, setText, getAccessibleContext, getUIClassID, getPreferredSize, addHyperlinkListener, createEditorKitForContentType, fireHyperlinkUpdate, getEditorKitForContentType, getHyperlinkListeners, getPage, registerEditorKitForContentType, registerEditorKitForContentType, removeHyperlinkListener, scrollToReference, setPage, setPage, getScrollableTracksViewportHeight, getScrollableTracksViewportWidth, getEditorKit, getEditorKitClassNameForContentType, replaceSelection, setEditorKit, setEditorKitForContentType, write, read, getActions, print, print, print, copy, select, getCaret, cut, paste, getMargin, setMargin, getText, selectAll, addInputMethodListener, getInputMethodRequests, setComponentOrientation, getUI, isEditable, setEditable, setUI, updateUI, getToolTipText, removeNotify, getDocument, modelToView, setCaretPosition, addCaretListener, addKeymap, getCaretColor, getCaretListeners, getDisabledTextColor, getFocusAccelerator, getHighlighter, getKeymap, getKeymap, getNavigationFilter, getSelectedTextColor, getSelectionColor, loadKeymap, moveCaretPosition, removeCaretListener, removeKeymap, setCaret, setCaretColor, setDisabledTextColor, setFocusAccelerator, setHighlighter, setKeymap, setNavigationFilter, setSelectedTextColor, setSelectionColor, setSelectionEnd, setSelectionStart, viewToModel, getSelectedText, getDragEnabled, getDropLocation, getDropMode, getPreferredScrollableViewportSize, getPrintable, getScrollableBlockIncrement, getScrollableUnitIncrement, setDragEnabled, setDropMode, getCaretPosition, getSelectionEnd, getSelectionStart, setDocument, update, contains, getLocation, print, getSize, isOpaque, disable, enable, setEnabled, getBounds, revalidate, addAncestorListener, firePropertyChange, firePropertyChange, firePropertyChange, getClientProperty, getListeners, addNotify, addVetoableChangeListener, computeVisibleRect, createToolTip, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getRegisteredKeyStrokes, getRootPane, getToolTipLocation, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintImmediately, paintImmediately, printAll, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, resetKeyboardActions, reshape, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, add, add, add, add, add, remove, remove, list, list, removeAll, invalidate, locate, layout, addPropertyChangeListener, addPropertyChangeListener, validate, getComponent, getLayout, getComponents, getComponentAt, getComponentAt, findComponentAt, findComponentAt, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getMousePosition, insets, isAncestorOf, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, minimumSize, paintComponents, preferredSize, printComponents, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, getFocusTraversalPolicy, isFocusCycleRoot, isFocusCycleRoot, setFocusTraversalPolicy, addContainerListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, getComponentCount, add, remove, toString, getName, contains, size, getLocation, getParent, setName, list, list, list, getSize, location, setSize, setSize, resize, resize, enable, isValid, isEnabled, action, bounds, getBounds, removePropertyChangeListener, removePropertyChangeListener, getLocale, setLocale, move, getGraphicsConfiguration, getMousePosition, handleEvent, isFocusOwner, isFocusable, isLightweight, postEvent, transferFocus, transferFocusBackward, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, checkImage, checkImage, createImage, createImage, createVolatileImage, createVolatileImage, enableInputMethods, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getKeyListeners, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMouseWheelListeners, getToolkit, gotFocus, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isFocusTraversable, isFontSet, isForegroundSet, keyDown, keyUp, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, paintAll, prepareImage, prepareImage, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, setCursor, setDropTarget, setFocusTraversalKeysEnabled, setFocusable, setIgnoreRepaint, show, show, transferFocusUpCycle, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getFocusCycleRootAncestor, getFont, getForeground, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getTreeLock, isDisplayable, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isVisible, nextFocus, repaint, repaint, repaint, setBounds, setBounds, setLocation, setLocation, dispatchEvent, wait, wait, wait, equals, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### public static final String AUTO_INDENT

    - #### public static final String FIND

    - #### public static final String FIND_NEXT

    - #### public static final String FIND_PREVIOUS

    - #### public static final String REPLACE

  - ### Property Detail

    - #### boolean overtypeMode

    - #### boolean unwrapped

  - ### Constructor Detail

    - #### public TextEditor()

      Creates a new instance of TextEditor

    - #### public TextEditor(boolean tabsAsSpaces)

      Creates a new instance of TextEditor

    - #### public TextEditor(boolean tabsAsSpaces, boolean multiLineTab)

      Creates a new instance of TextEditor

    - #### public TextEditor(boolean tabsAsSpaces, boolean multiLineTab, boolean unwrapped)

      Creates a new instance of TextEditor

  - ### Method Detail

    - #### public void addNotify()

    - #### public int getNumberOfPages()

    - #### public PageFormat getPageFormat(int pageIndex)

    - #### public Printable getPrintable(int param)

    - #### public boolean getScrollableTracksViewportWidth()

    - #### public boolean isMultiLineTabbed()

      Whether using the tab key indents the selected lines of code

      Returns:
        true if multiline tabbing is active

    - #### public void isMultiLineTabbed(boolean multiLineTab)

      Parameters:
        `multiLineTab` - the new multiLine tab value

    - #### public static boolean isOvertypeMode()

      Returns:
        true if overtype mode is active, false for insert mode

    - #### public boolean isTabsAsSpaces()

      Returns:
        true if tabs are converted to spaces upon typing

    - #### public void isTabsAsSpaces(boolean tabsAsSpaces)

      Parameters:
        `tabsAsSpaces` - whether tabs are converted to spaces

    - #### public boolean isUnwrapped()

      Returns:
        true if text wrapping is disabled

    - #### public int print(Graphics graphics, PageFormat pageFormat, int page)

    - #### protected void processKeyEvent(KeyEvent e)

    - #### public void removeNotify()

    - #### public void replaceSelection(String text)

    - #### public void setBounds(int x, int y, int width, int height)

    - #### public void setOvertypeMode(boolean isOvertypeMode)

      Set the caret to use depending on overtype/insert mode

      Parameters:
        `isOvertypeMode` - the new mode; true = overtype

    - #### public void setUnwrapped(boolean unwrapped)

      Parameters:
        `unwrapped` - the new unwrapped value